Bug 1756902 - Incorrectly evaluated rich deps
Summary: Incorrectly evaluated rich deps
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: dnf-plugins-core
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jaroslav Mracek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-09-30 07:49 UTC by Miroslav Suchý
Modified: 2020-05-05 07:16 UTC (History)
8 users (show)

Fixed In Version: dnf-plugins-core-4.0.11-1.fc31
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-05 07:16:55 UTC
Type: Bug


Attachments (Terms of Use)

Description Miroslav Suchý 2019-09-30 07:49:23 UTC
Description of problem:
Originally reported as 
  https://github.com/rpm-software-management/mock/issues/336

Version-Release number of selected component (if applicable):
dnf-plugins-core-4.0.9-1.fc31.noarch

How reproducible:
deterministic

Steps to Reproduce:
Create a dummy spec file with:
  BuildRequires:  python3
  BuildRequires:  (python3dist(importlib-metadata) if python3 < 3.8)

important! no other BR! Otherwise, it may work.

run
  mock -r fedora-rawhide-x86_64 init

run:
  LC_ALL=C sudo /usr/bin/dnf builddep --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 32 --setopt=deltarpm=False --allowerasing  /home/msuchy/rpmbuild/SRPMS/evil-1-1.fc31.src.rpm

No matching package to install: '(python3dist(importlib-metadata) if python3 < 3.8.0~b3)'
Package python3-3.8.0~b4-1.fc32.x86_64 is already installed.

This should pass without requiring `importlib-metadata` on Fedora 32.

Comment 1 Miro Hrončok 2019-09-30 07:57:57 UTC
I guess the system that runs the reproducer must not yet have Python 3.8 (i.e. it needs to be Fedora 29, 30 or 31).

Comment 2 Jaroslav Mracek 2019-09-30 08:26:25 UTC
I create patch that make test for matches conditional - it is not applied for richdeps (https://github.com/rpm-software-management/dnf-plugins-core/pull/362). In case that richdep has no match, only solver can decide during resolve phase whether it is problem or not.

Please could you provide a feedback on the patch?

Comment 3 Miroslav Suchý 2019-09-30 08:39:07 UTC
It happens to me on F31. Setting the version accordingly. Feedback provided in PR.

Comment 4 Miro Hrončok 2019-09-30 08:48:23 UTC
It happens to me on F30. I have a reason to believe this also happens on F29. I've ste the lowest possible version where this needs to be fixed.

Feedback also provided in the PR.

Comment 5 Fedora Update System 2019-11-11 09:43:07 UTC
FEDORA-2019-7cafbe66ba has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-7cafbe66ba

Comment 6 Fedora Update System 2019-11-11 09:43:40 UTC
FEDORA-2019-94393775ec has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-94393775ec

Comment 7 Fedora Update System 2019-11-12 03:07:35 UTC
dnf-4.2.15-1.fc30, dnf-plugins-core-4.0.11-1.fc30, dnf-plugins-extras-4.0.8-1.fc30, libdnf-0.37.2-2.fc30, librepo-1.11.0-1.fc30, microdnf-3.0.2-1.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-7cafbe66ba

Comment 8 Fedora Update System 2019-11-13 04:56:04 UTC
dnf-4.2.15-1.fc31, dnf-plugins-core-4.0.11-1.fc31, dnf-plugins-extras-4.0.8-1.fc31, libdnf-0.37.2-2.fc31, librepo-1.11.0-1.fc31, microdnf-3.0.2-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-94393775ec

Comment 9 Fedora Update System 2019-11-14 06:46:49 UTC
FEDORA-2019-7cafbe66ba has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-7cafbe66ba

Comment 10 Fedora Update System 2019-11-14 06:50:35 UTC
FEDORA-2019-94393775ec has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-94393775ec

Comment 11 Fedora Update System 2019-11-15 03:45:00 UTC
dnf-4.2.15-3.fc30, dnf-plugins-core-4.0.11-1.fc30, dnf-plugins-extras-4.0.8-1.fc30, libdnf-0.37.2-2.fc30, librepo-1.11.0-1.fc30, microdnf-3.0.2-1.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-7cafbe66ba

Comment 12 Fedora Update System 2019-11-15 04:38:33 UTC
dnf-4.2.15-2.fc31, dnf-plugins-core-4.0.11-1.fc31, dnf-plugins-extras-4.0.8-1.fc31, libdnf-0.37.2-2.fc31, librepo-1.11.0-1.fc31, microdnf-3.0.2-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-94393775ec

Comment 13 Fedora Update System 2019-11-19 01:35:05 UTC
dnf-4.2.15-2.fc31, dnf-plugins-core-4.0.11-1.fc31, dnf-plugins-extras-4.0.8-1.fc31, libdnf-0.37.2-2.fc31, librepo-1.11.0-1.fc31, microdnf-3.0.2-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2019-12-02 19:10:25 UTC
dnf-4.2.15-3.fc30, dnf-plugins-core-4.0.11-1.fc30, dnf-plugins-extras-4.0.8-1.fc30, libdnf-0.37.2-2.fc30, librepo-1.11.0-1.fc30, microdnf-3.0.2-1.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.